#!/bin/bash
# Questo script cerca di correggere la mancata visualizzazione dei file info
# scritto il 15 settembre 2011 da Giovanni Ubaldi www.ubaweb.it
# messo procedimento automatico il 16/09/2011
# Lo script deve essere eseguito con i privilegi dell'amministratore
msg_prog="Questo script richiede che siano istallati gedit e xterm
se non fossero istallati o si volessero usare altri programmi
sostituire in questo script \"gedit\" con il vostro editor e 
\"xterm\" con la vostra console grafica 8-)"
msg_help="\nQuesto script non ha bisogno di parametri ma
deve essere eseguito da utente root! Per esempio, con sudo:\n
\t\t sudo ./ripara_info.sh\n"
msg_prova="\n---Premendo un tasto verrà aperto un terminale grafico per la prova di info ---\n"
msg_prova2="\n\n\nFunziona? Si vedono le info su info?\n\nSe si, bene! Premendo invio il programma si chiuderà e...\n\n\t\t Bye bye by UbaWeb 9-)
\n\t---Se info continua a non funzionare premere il tasto \"n\"---\n"
file_menu="/usr/share/info/dir"
up_info="/usr/sbin/update-info-dir"
clear
if [ "$UID" -ne 0 ]
then
  echo -e "$msg_help."
  exit 1
fi  
# Controllo programmi
editor=$(which gedit)
if [ $? -ne 0 ]
	then
		echo -e "\n!!!L'editor di testo predefinito non è stato trovato!!! 8-|
!!! NON SARÀ POSSIBILE ESEGUIRE LA PROCEDURA MANUALE!!!
SCEGLIERE LA PROCEDURA AUTOMATICA QUANDO RICHIESTO!
Almeno fino a quando non si fanno le dovute modifiche allo script.\n
$msg_prog"
		noeditor=1
fi

console=$(which xterm)
if [ $? -ne 0 ]
	then
		echo -e "\nXterm non è stato trovato! 8-|\n
$msg_prog"
		exit
fi
p_upinfo=$(which update-info-dir)
if [ $? -ne 0 ]
	then
		echo -e "\n!!!-- update-info-dir non è stato trovato --!!! 8-/\n
Provare a cercarlo manualmente e se trovato aggiungere il percorso a PATH,\nse non esiste reistallare info. 8-(\n"
		exit
fi
if [ $# -ne 0 ]
	then
		echo -e "$msg_help"
exit 
fi

echo -e "\n\t\t\t Vediamo di sistemare le \"info\"\n
Per sicurezza sposto il file $file_menu nella directory utente."
if [ -e /usr/share/info/dir ]
	then
		mv $file_menu ~/dir
		echo -e "Ok! Spostato.\n"
	else
		echo "Il file non esiste! Bene! Alla fine verrà ricreato"
fi

if [ -e "$up_info" ]
	then
		# controllo le prime 20 righe del file update-info-dir per vedere se ha le giuste impostazioni
		head -n 20 $up_info | grep -v ^# | grep "unset LANG " &> /dev/null
		if [ $? -eq 0 ]
			then
				echo "Ok il file update-info-dir sembra avere le giuste impostazioni!
eseguo update-info-dir."
				$p_upinfo &> /dev/null
			else
				echo -e "\nSi devono inserire le giuste impostazioni nel file \"$up_info\"\n"
				echo -e "Si può scegliere la procedura automatica premendo un tasto qualsiasi\noppure quella manuale premendo il tasto \"m\""
				read -sn 1 automan
				clear
				if [ "$automan" = "m" -o "$automan" = "M" ]
					then # modifica al file manuale
						if [ "$noeditor" -ne 1 ]
							then
								echo -e "Tra poco verrà chiesto di aprire il file con gedit.\nDopo l'apertura individuare la riga \"unset LANGUAGE\", 
copiare le due righe qui sotto e incollarle subito sotto \"unset LANGUAGE\"\n\n
# La riga sotto è stata inserita per correggere il bug 70793 delle info
unset LANG \n\n
Quando si è fatto: salvare, chiudere gedit e tornare a questa finestra.\n\n\t---Premere un tasto per aprire il file con gedit---\n"
								read -sn 1
								clear
								$editor $up_info
								echo -e "\n\n\tSalvate le modifiche? Se si, premere un tasto per continuare\n"
								read -sn 1
								clear
								echo -e "\nEseguo \"update-info-dir\" per correggere il problema\n"	
								$p_upinfo &> /dev/null
							else
								echo -e "Non puoi usare la modifica manuale perché non è stato trovato 
l'editor di testo predefinito! 
Posegui fino alla fine premendo \"n\" quando ti verrà chiesto oppure
riesegui questo script e la prossima volta scegli la modalità automatica"
						fi
					else # modifica al file automatica
						sudo cp /usr/sbin/update-info-dir ~/update-info-dir
						echo "Ho creato una copia di sicurezza del file nella home dell'utente"
						sudo sed s/'unset LANGUAGE'/'unset LANGUAGE \n# La riga sotto è stata inserita per correggere il bug 70793 delle info\nunset LANG'/g "$up_info" > 							$up_info"_r"
						if [ $? -eq 0 ]
							then
								echo -e "Il file $file_orig è stato salvato correttamente"
								cp $up_info"_r" $up_info
								echo "È stata fatta una copia del file con nome ${up_info}_r"
								$p_upinfo &> /dev/null
							else
								echo "Errore nell'esecuzione del comando"
						fi
						
				fi
		fi
	else
		echo -e "\n\t!!! Il file $up_info non esiste!!!\n
Forse sarà necessaria una nuova istallazione di \"info\".\n
Ma prima, continuare a seguire le istruzioni di questo script.\n"
fi

echo -e "$msg_prova"
echo -e "\n\nPremere un tasto per aprire xterm e provare info\n"
read -sn 1
$console -e info info &
clear
echo -e "$msg_prova2"
echo -e "Lo script proverà a ripristinare \"info\" automaticamente usando un metodo\ndiverso"
read -sn 1
if [ "$REPLY" = "n" -o  "$REPLY" = "N" ]
	then
		echo -e "\nAttendere!\n"
		LANG=en_US.UTF-8
		grep "ginstall-info " $up_info &> /dev/null
		if [ $? -eq 0 ]
			then
				for file in /usr/share/info/*.{gz,info} /usr/share/info/*/*.{gz,info}; do
				sudo ginstall-info "$file" /usr/share/info/dir &> /dev/null
				done
			else
				for file in /usr/share/info/*.{gz,info} /usr/share/info/*/*.{gz,info}; do
				sudo install-info "$file" /usr/share/info/dir &> /dev/null
				done
		fi
	else
		exit 0
fi

echo -e "$msg_prova"
echo -e "\n\nPremere un tasto per aprire xterm\n"
read -sn 1
$console -e info info &
clear
echo -e "$msg_prova2"
echo "Verranno date altre informazioni per cercare di risolvere il problema"
read -sn 1
if [ "$REPLY" = "n" -o  "$REPLY" = "N" ]
	then
		clear
		echo -e "1)\tProvare ad eseguire nuovamente il programma. 
\tSe non si rimedia nemmeno con una nuova esecuzione provare a:\n
a)\tDigitare:\n\t\tsudo gedit $up_info
\te controllare che \"unset LANG\" sia presente nelle prime 20 righe
\tcomunque deve essere presente prima dei blocchi di codice \"if\"
\t(semmai aumentare il numero dopo -n alla riga 49 di questo script).

b)\tControllare il sorgente di questo script e verificare che
\ti percorsi indicati puntino realmente ai file sul vostro sistema
\tnel caso non fosse così modificarli, in questo script,
\taffinché puntino ai file reali.

c)\tProvare a disistallare e reistallare info, poi eseguire questo script\n\n
\t\tBye bye by UbaWeb e in bocca al lupo 8-)\n\n"
	else	
		exit 0
fi
